var request = require('request');

function httpRequest(method, url, data) {
  // 封装request请求 post get
  // console.log(data);
  if (method === 'get') {
    return new Promise(function(resolve, reject) {
      request({
        url: url,
        method: 'GET',
        form: data
      }, function(err, response, body) {
        var data = JSON.parse(body);
        resolve(data);
        //   res.json(data)
      });
    });
  } else if (method === 'post') {
    return new Promise(function(resolve, reject) {
      request({
        headers:{"content-type": "application/json"},
        url: url,
        method: 'POST',
        body: JSON.stringify(data),
        rejectUnauthorized: false
      }, function(err, response, body) {
        if (typeof body === 'undefined'){
          resolve(err)
        } else {
          var data = JSON.parse(body);
          resolve(data);
        }
        //   res.json(data)
      });
    });
  }
}
global.httpRequest = httpRequest;
