const Base = require('./base.js');
const handle = require('../handle/edit')
module.exports = class extends Base {
  indexAction() {
    return this.display();
  }
  
  //修改活动表
  async editActiveAction() { 
    const param = this.post();
    let activeData = await this.model('activity').where({id:param.id}).find();
    let result = await handle.editDataBase(activeData, param, 'activity_copy');
    if (result === 1) {
      return this.success();
    } else {
      return this.fail(3008, '修改失败');
    }
    
  }

  //修改人员表
  async editPersonFamilyAction() { 
    const param = this.post();
    let personData = await this.model('person').where({id:param.id}).find();
    let familyData = await this.model('family').where({personID:param.id}).select();
    let persRes = await handle.editDataBase(personData, param, 'person_copy'); 
    if (persRes != 1) {
      return this.fail(3010, 'update person failed')
    }
    let handleData = await handle.getIdsArrAndMustParam(familyData,param.family);
    let familyNewData = await handle.combineData(handleData,param.createPerosn,param.createAccount);
    console.log(familyNewData)
    if (familyNewData.status == 0) {
      console.log(param.id)
      let familyRes = await handle.delAndInsertData(handleData.newD, 'family', {personID: param.id})
      let familyCopyRes = await this.model('family_copy').addMany(handleData.oriData).catch((err) => {
        console.log(err)
        return think.isError(err) ? err : new Error(err);
      })
      if (think.isError(familyCopyRes)) {
        return this.fail(3011, 'Add family_copy failed');
      }
    }
    return this.success()
    
  }

  //修改实现表
  async editMatterAction() {
    const param = this.post();
    let matterData = await this.model('matter').where({activityID:param[0].activityID})
    let matterHandleData = getIdsArrAndMustParam(matterData,param);
    let matterNewData = handle.combineData(matterHandleData,param.createPeson,param.createAccount);
    if (matterNewData.status == 0) {
      let matterRes = handle.delAndInsertData(matterNewData.newD, 'matter', {activityID: param[0].activityID})
      let matterCopyRes = await this.model('matter_copy').addMany(matterNewData.oriData)
    }
    return this.success();
  }
};
