const moment = require('moment');
/*
考核得分方法
*/
// 考核加分
// type 考核加分类型,如下
// 1效能考核（每日签到）
// 2登记信访件（每登记一次）
// 3登记完整度（有个别选项加分）
// 4办理信访件（每流转一次）
// 5人民意见转信访件（互联网加分）
// userid 用户id
// 返回0,错误;返回大于0,成功
async function addPoints(type, userid) {
  const user = await think.model('sys_user').where({'user_id': userid}).select();
  if (user.length === 1) {
    const org = await think.model('sys_organization').where({'id': user[0].orgID}).select();
    const rule = await think.model('kh_point_rules').where({'id': type}).select();

    if (rule[0].id === 1) {
      const details = await think.model('kh_point_detail').where({
        creatorId: userid,
        pointID: rule[0].id,
        time: {'>=': moment().format('YYYY-MM-DD'), '<=': moment().add(1, 'days').format('YYYY-MM-DD')}
      }).select();
      if (details.length >= 1) {
        return details[0].id;
      } else {
        const insertPoint = {
          creatorID: user[0].user_id,
          creatorName: user[0].name,
          orgName: org[0].orgName,
          orgID: user[0].orgID,
          pointID: rule[0].id,
          pointName: rule[0].typeName,
          point: rule[0].point
        };
        const isertID = await think.model('kh_point_detail').add(insertPoint);
        return isertID;
      }
    } else {
      // const insertPoint = {
      //   creatorID: user[0].user_id,
      //   creatorName: user[0].name,
      //   orgName: org[0].orgName,
      //   orgID: user[0].orgID,
      //   pointID: rule[0].id,
      //   pointName: rule[0].typeName,
      //   point: rule[0].point
      // };
      // const isertID = await think.model('kh_point_detail').add(insertPoint);
      return 0;
    }
  } else {
    return 0;
  }
}

module.exports = {
  addPoints
};
