//判断字典是否一致
function judgeObjectSameValue(originalData, newData) { 
  for (key in newData) {
    if (key == 'creatTime' || key == 'createPerson' || key == 'createAccount' || key == 'id') continue;
    if (originalData[key] != newData[key]) {
      return 0;
    }
    return 1;
  }
}

function judgeArrObjectSameValue(originalData, newData) { 
  let flag = 0; //0是有变化;
  if(originalData.length == newData.length) {
    for (let i = 0; i< newData.length; i++) {
      if (JSON.stringify(originalData).includes(JSON.stringify(newData[i]))) {
        flag = 1;
      } else {
        flag = 0;
        break;
      } 
    }
  }
  console.log(flag)
  return flag;
}
//获取ids数组和去掉没有必要字段的参数
async function getIdsArrAndMustParam(originalData,newData) {
  // let oriIds,oriData,newIds,newD = [];
  let oriIds = [];
  let oriData = [];
  let newIds = [];
  let newD = [];
  originalData.forEach((item)=> {
    oriIds.push(item.id)
    oriData.push(item)
    delete item.createAccount;
    delete item.createPerson;
    delete item.createTime;
    
  })
  newData.forEach((value) => {
    newIds.push(value.id);
    newD.push(value)
    delete value.createAccount;
    delete value.createPerson;
    delete value.createTime;
    
  })
  const data = {oriData:oriData,oriIds:oriIds,newIds:newIds,newD:newD,originalData:originalData,newData:newData}
  return data;
}
//判断旧数据中的ids是否在新数据中都存在
function isIdsInNewData(oriIds, newIds) {
  let notExitIds = []
  oriIds.forEach((v) => {
    if (newIds.indexOf(v) === -1) {
      notExitIds.push(v)
    }
  })
  return notExitIds;
}
//重组原来数据
async function combineData(data,person,account) {
  let notExitId = isIdsInNewData(data.oriIds, data.newIds);
  console.log(notExitId);
  let status = 0
  if (notExitId.length>0) {
    data.oriData.forEach((item) => {
      item.updateTime= think.datetime(new Date());
      item.updatePerson = person;
      item.updateAccount = account;
      item.uuid = think.uuid().split('-').join('');
      notExitId.forEach((id)=> {
        if(item.id == id) {
          item.flag = 0
        } else {
          item.flag = 1
        }
      })
      delete item.id;
    })
  } else {
    if (data.originalData.length == data.newData.length){
      let flag = judgeArrObjectSameValue(data.originalData, data.newData);
      if (flag !== 0) {
        status = 1
      } 
    }
    data.oriData.forEach((v) => {
      delete v.id;
      v.updateTime= think.datetime(new Date());
      v.updatePerson = person;
      v.updateAccount = account;
      v.uuid = think.uuid().split('-').join('');
    })
  }
  return {status: status, oriData:data.oriData}
}

//删除原始数据并插入新数据
async function delAndInsertData(data,tableName,param){
  let delData = await think.model(tableName).where(param).delete().catch((err) => {
    return think.isError(err) ? err : new Error(err);
  });
  if (think.isError(delData)) {
    return 0
  }
  let res = await think.model(tableName).addMany(data).catch();
  return 1;
}

async function editDataBase(originalData,newData,tableName) { 
  let isSameValue = judgeObjectSameValue(originalData, newData);
  if(isSameValue === 0) {
    originalData.updateTime = think.datetime(Date.now());
    originalData.updatePerson = newData.createPerson;
    originalData.updateAccount = newData.createAccount;
    delete originalData.id;
    resultCopy = await think.model(tableName).add(originalData).catch((err) => {
      console.log(err);
      return think.isError(err) ? err : new Error(err)
    });
    if (think.isError(resultCopy)) {
      return 2;
    } 
    result = await think.model(tableName.split('_')[0]).where({id: newData.id}).update(newData).catch((err) => {
      console.log(err);
      return think.isError(err) ? err : new Error(err)  
    })
    if (think.isError(resultCopy)) {
      return 2;
    } 
    return 1
  } else {
    return 1;
  }
 
  
}

module.exports = {
  editDataBase, 
  getIdsArrAndMustParam,
  combineData,
  delAndInsertData
  
}