module.exports = class extends think.Logic {
  getListAction() {
    this.allowMethods = 'post';
    const rules = {
      limit: {
        int: true, // 字段类型为 int 类型
        default: 10 // 默认值
      },
      page: {
        int: true, // 字段类型为 int 类型
        default: 0 // 默认值
      },
      type: {
        int: true, // 字段类型为 int 类型
        default: 0 // 全选
      },
      state: {
        int: true, // 字段类型为 int 类型
        default: 0 // 未采纳
      },
      startTime: {
        string: true, // 字段类型为 int 类型
        default: ""// 默认值
      },
      endTime: {
        string: true, // 字段类型为 int 类型
        default: "" // 默认值
      }
    };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  };
  isAdoptAction() {
    this.allowMethods = 'post';
    const rules = {
      id: {
        int: true, // 字段类型为 int 类型
        required: true // 必填
      },
      state: {
        int: true, // 字段类型为 int 类型
        required: true, // 必填
        in:[1,2] //1采纳，2不采纳
      }
    };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  }
}
