module.exports = class extends think.Logic {
  addRoleAction() {
    this.allowMethods= 'post';
    const rules= {
      role_name: {
        required: true,
        string: true,
        trim: true
      }
    }
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  }

  editRoleAction() {
    this.allowMethods = 'post';
    const rules =  {
      role_id: {
        required: true,
        int: true,
      },
      role_name: {
        required: true,
        string: true,
        trim: true
      }
    }
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  }

  
}