const uuid = require('node-uuid');
module.exports = class extends think.Model {
  // 配置关联关系
  get relation() {
    return {
      cate: { // 配置跟分类的关联关系
        type: think.Model.HAS_ONE,
        // type: think.Model.BELONG_TO,
        name: 'person', //对查询的key重命名
        model: 'person', // 关联表
        key: 'mainPerson', // 关联字段
        fKey: 'id', // key对应的关联字段
        // field: 'id,name' // 只查询 id, name 字段
      },
      // person: { // 配置跟评论的关联关系
      //
      // }
    }
  };
  // 设置表结构
  get schema() {
    return {
      id: { // 字段名称
        type: 'varchar(255)',
        default: uuid.v1()
      }
    }
  }
};
