const uuid = require('node-uuid');
module.exports = class extends think.Model {
  // 设置表结构
  get schema() {
    return {
      id: { // 字段名称
        type: 'varchar(255)',
        default: uuid.v1()
      }
    }
  };
  // 配置关联关系
  get relation() {
    return {
      // cate: { // 配置跟分类的关联关系
      activity: { // 配置跟分类的关联关系
        type: think.Model.HAS_ONE,
        // type: think.Model.BELONG_TO,
        name: 'activity', //对查询的key重命名
        model: 'activity', // 关联表
        key: 'activityID', // 关联字段
        fKey: 'id', // key对应的关联字段
        // field: 'id,name' // 只查询 id, name 字段
      },
      handle_log: {
        type: think.Model.HAS_MANY,
        model:'handle_log',
        name: 'handle_log',
        fKey: 'matterID',
        key: 'id',
        order:'createTime ASC'// 查询排序
      }
    }
  };
}
