//包括短信发送记录
const Base = require('./../base.js');

module.exports = class extends Base {
  indexAction() {
    return this.display();
  }

  /**
   * showdoc
   * @catalog 短信相关
   * @title 平台短信发送记录列表接口
   * @description 平台短信发送记录列表接口
   * @method post
   * @param personName 可选 string 接收人姓名
   * @param page 必选 int 第几页
   * @param limit 必选 int 每页条数
   * @url http://127.0.0.1:8360/msg/sms/smsSendList
   * @return {"errno": 0, "errmsg":""}
   */
  async smsSendListAction() {
    const data = this.post();
    data.page = data.page === undefined ? 0 : data.page;
    data.limit = data.limit === undefined ? 0 : data.limit;
    data.personName = data.personName === undefined ? '' : data.personName;
    let where = 'sendType = 1';
    if (data.personName !== '') {
      where += ' and personName like "%' + data.personName + '%"';
    }
    const back = await this.model('tell_log').where(where).page(data.page, data.limit).order('sendTime DESC').countSelect();// 时间倒序
    this.success(back);
  }

};
