
// 验证是否为安徽常驻人口，姓名与身份证匹配
async function check(name,idcard) {
  //
  const data = {
    "SenderId":"C10-10000001",// 请求方Id固定
    "ServiceId":"S10-10000001",// 目标服务方Id固定
    "AuthorizeInfo":"72C3-3829-2A7D-892A",
    "EndUser":{
      "UserCardId":"34010419701002151X",
      "UserName":"张庆",
      "UserDept":"010000",
      "UserIp":"61.190.70.11",// 应当是请求方ip
      "CallReason":"测试"
    },
    "Method":"DataCheck",
    "Params":{} // 需要传参
  };
  const Params_1 = {
    "Condition":"XM,SFZH",
    "SourceDataSet":[
      {
        "XM":name,
        "SFZH":idcard
      }
    ],
    "ReceiveServiceId":""
  };
  const Params_2 = {
    "Condition":"SFZH",
      "SourceDataSet":[
      {
        "SFZH":idcard
      }
    ],
      "ReceiveServiceId":""
  }
  // 第一次验证赋值
  data['Params'] = Params_1;
  const back = await httpRequest('post','https://172.28.50.118/DCPeer/router/proxy/74588/96ffd0cc-6b30-403e-95c2-802492a8859a',data);
  if (back.PayLoad.Code === '000'){
    // 正常结果返回
    if (back.PayLoad.Data.Result[0].CheckResult === '1'){
      // 安徽省常住人口验证通过
      return 1
    }else {
      // 安徽省常住人口验证不通过
      // 进行二次验证 赋值
      data['Params'] = Params_2
      const back_2 = await httpRequest('post','https://172.28.50.118/DCPeer/router/proxy/74588/96ffd0cc-6b30-403e-95c2-802492a8859a',data);
      if (back_2.PayLoad.Code === '000'){
        if (back_2.PayLoad.Data.Result[0].CheckResult === '1'){
          // 常驻人口身份证通过，名字不符
          return 2
        }else {
          // 人员不在安徽常驻人口库中，默认为待核验状态
          return 3
        }
      }else {
        // 接口异常
        return 99
      }
    }
  }else {
    // 接口异常
    return 99
  }

}

module.exports = {
  check
}
