module.exports = class extends think.Logic {
  indexAction() {

  }
  addAction() {
    this.allowMethods = 'post';
    const rules = {
      family: {
        array: true,
        // requiredIf: ['personID', 0], // personID为0时必填
        default: [] // 默认值
      },
      delFamily: {
        array: true,
        // requiredNotIf: ['personID', 0], // personID不为0时必填
        default: [] // 默认值
      },
      addFamily: {
        array: true,
        // requiredNotIf: ['personID', 0], // personID不为0时必填
        default: [] // 默认值
      },
      activityID: {
        string: true,
        // required: true,
        default: '' // 默认值
      },
      xfType: {
        array: true,
        requiredIf: ['activityID', 0], // activityID为0时必填
        default: [] // 默认值
      },
      xfTypeID: {
        array: true,
        requiredIf: ['activityID', 0], // activityID为0时必填
        default: [] // 默认值
      },
      unit: {
        default:""
      },
      position: {
        default:""
      },
      grade: {
        default:""
      },
      due: {
        default:""
      },
      zone: {
        default:""
      }
      };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  }
  listAction() {
    this.allowMethods = 'post';
    const rules = {
      limit: {
        int: true, // 字段类型为 int 类型
        default: 10 // 默认值
      },
      page: {
        int: true, // 字段类型为 int 类型
        default: 0 // 默认值
      }
    };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  }
  findAction() {
    this.allowMethods = 'post';
    const rules = {
      id: {
        int: true, // 字段类型为 int 类型
        required: true // 必填项
      }
    };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  }
  selectAction() {
    const rules = {
      limit: {
        int: true, // 字段类型为 int 类型
        default: 10 // 默认值
      },
      page: {
        int: true, // 字段类型为 int 类型
        default: 0 // 默认值
      },
      name: {
        string: true,
        required: true
      }
    };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  };
  byActivityAction() {
    const rules = {
      limit: {
        int: true, // 字段类型为 int 类型
        default: 10 // 默认值
      },
      page: {
        int: true, // 字段类型为 int 类型
        default: 0 // 默认值
      }
    };
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  }
};
