module.exports = class extends think.Logic {
  addDelegateLeadAction() {
    // this.allowMethods = 'post';
    var regIdCard=/^(^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$)|(^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])((\d{4})|\d{3}[Xx])$)$/;
    const rules = {
      name: {
        required: true,
        string: true,
        trim: true
      },
      serveStartTime: {
        date: true,
      },
      zoneID: {
        int: true
      },
      serveEndTime:{
        date: true
      }
    }
    const flag = this.validate(rules);
    if (!flag) {
      return this.fail('validate error', this.validateErrors);
    }
  }
}